! This file is part of HiggsBounds
!  -KW
!******************************************************************
module S95tables_type1
!******************************************************************	

 implicit none
 
 !table type 1-----------------------------	
 type table1	
  integer :: id,nx,OBid_old,OBid
  character(LEN=30) :: label
  character(LEN=3) :: expt	
  double precision :: Mhmax,Mhmin,sep,deltaMh
  double precision, pointer :: dat(:,:) !in dat(a,1:2)... obs=1,pred=2		
 end type
 !------------------------------------------ 
 
 contains
 
 !************************************************************ 
 subroutine initializetables1(S95_t1)
 !***********************************************************  
 ! fills S95_t1
 !*********************************************************** 
  use store_pathname
  implicit none

  !--------------------------------------input
  type(table1) :: S95_t1(:)
  !-----------------------------------internal
  logical :: newtables
  integer :: i,x,xbeg,xend	
  character(len=100),allocatable :: filename(:)
  character(LEN=200) :: fullfilename	
  !-------------------------------------------  
  
  xbeg=lbound(S95_t1,dim=1)
  xend=ubound(S95_t1,dim=1)
  
  allocate(filename(xbeg:xend))    
  x=xbeg-1

  newtables=.True.  ! i.e. use the recommended LEP single Higgs tables
  if(newtables)then   
   x=x+1
   S95_t1(x)%id=142
   S95_t1(x)%expt='LEP'				
   S95_t1(x)%label='LEP table 14b' ! table 14b
   S95_t1(x)%Mhmin=12.0D0
   S95_t1(x)%Mhmax=120.0D0
   S95_t1(x)%sep=0.5D0
   filename(x)='lep210_hbb'
   S95_t1(x)%OBid_old=1
   S95_t1(x)%OBid=1
  
   x=x+1
   S95_t1(x)%id=143
   S95_t1(x)%expt='LEP'		
   S95_t1(x)%label='LEP table 14c' ! table 14c
   S95_t1(x)%Mhmin=4.0D0
   S95_t1(x)%Mhmax=120.0D0
   S95_t1(x)%sep=0.5D0	
   filename(x)='lep210_htt_interpol'
   S95_t1(x)%OBid_old=2
   S95_t1(x)%OBid=2
  else
   write(*,*)'WARNING: using old LEP tables' 
   x=x+1
   S95_t1(x)%id=142
   S95_t1(x)%expt='LEP'		
   S95_t1(x)%label='LEP table 14b' ! table 14b
   S95_t1(x)%Mhmin=1.0D0
   S95_t1(x)%Mhmax=140.0D0
   S95_t1(x)%sep=0.1D0
   filename(x)='old-s95_h2z_bbz'
   S95_t1(x)%OBid_old=1
   S95_t1(x)%OBid=1
  
   x=x+1
   S95_t1(x)%id=143 
   S95_t1(x)%expt='LEP'    
   S95_t1(x)%label='LEP table 14c' ! table 14c
   S95_t1(x)%Mhmin=1.0D0
   S95_t1(x)%Mhmax=140.0D0
   S95_t1(x)%sep=0.1D0
   filename(x)='old-s95_h2z_ttz'  
   S95_t1(x)%OBid_old=2
   S95_t1(x)%OBid=2
  endif
  
  !x=x+1 
  !S95_t1(x)%id=8742
  !S95_t1(x)%expt='CDF'				
  !S95_t1(x)%label='CDF Note 8742' ! table from CDF note 8742
  !S95_t1(x)%Mhmin=100.0D0
  !S95_t1(x)%Mhmax=150.0D0
  !S95_t1(x)%sep=5.0D0
  !filename(x)='CDF_ZH_llbb_1fb_8742_interpol' 
  !S95_t1(x)%OBid_old=2
  
!   x=x+1
!   S95_t1(x)%id=7081
!   S95_t1(x)%expt='CDF'
!   S95_t1(x)%label='arxiv 070810 (CDF)'
!   S95_t1(x)%Mhmin=110.0D0
!   S95_t1(x)%Mhmax=150.0D0
!   S95_t1(x)%sep=5.0D0
!   filename(x)='CDF_ZH_nunubb_1.7fb_070810_interpol'
!   S95_t1(x)%OBid_old=3
  
! !   x=x+1
! !   S95_t1(x)%id=8958 
! !   S95_t1(x)%expt='CDF' 
! !   S95_t1(x)%label='CDF Note 8958' 
! !   S95_t1(x)%Mhmin=110.0D0
! !   S95_t1(x)%Mhmax=200.0D0
! !   S95_t1(x)%sep=10.0D0
! !   filename(x)='CDF_ggH_WW_1.9fb_8958' 
! !   S95_t1(x)%OBid_old=6
! !   S95_t1(x)%OBid=6
   
!   x=x+1
!   S95_t1(x)%id=8957
!   S95_t1(x)%expt='CDF'
!   S95_t1(x)%label='CDF Note 8957' 
!   S95_t1(x)%Mhmin=110.0D0
!   S95_t1(x)%Mhmax=150.0D0
!   S95_t1(x)%sep=5.0D0
!   filename(x)='CDF_WH_lnubb_1.7fb_8957_interpol'
!   S95_t1(x)%OBid_old=1  
!   S95_t1(x)%OBid=1  

!   x=x+1
!   S95_t1(x)%id=5489
!   S95_t1(x)%expt=' D0'
!   S95_t1(x)%label='D0 Note 5489' 
!   S95_t1(x)%Mhmin=120.0D0
!   S95_t1(x)%Mhmax=200.0D0
!   S95_t1(x)%sep=20.0D0
!   filename(x)='D0_ppH_WW_emu_0.6fb_5489'
!   S95_t1(x)%OBid_old=8
!   S95_t1(x)%OBid=8
  
  !x=x+1
  !S95_t1(x)%id=5537
  !S95_t1(x)%expt=' D0'
  !S95_t1(x)%label='D0 Note 5537' 
  !S95_t1(x)%Mhmin=120.0D0
  !S95_t1(x)%Mhmax=200.0D0
  !S95_t1(x)%sep=20.0D0
  !filename(x)='D0_ppH_WW_ll_1.7fb_5537'
  !S95_t1(x)%OBid_old=-1
  
  x=x+1
  S95_t1(x)%id=5586
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='D0 Note 5586' 
  S95_t1(x)%Mhmin=105.0D0
  S95_t1(x)%Mhmax=145.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='D0_ZH_nunubb_2.1fb_5586'
  S95_t1(x)%OBid_old=5
  S95_t1(x)%OBid=5
  
!   x=x+1
!   S95_t1(x)%id=5482
!   S95_t1(x)%expt=' D0'
!   S95_t1(x)%label='D0 Note 5482' 
!   S95_t1(x)%Mhmin=105.0D0
!   S95_t1(x)%Mhmax=145.0D0
!   S95_t1(x)%sep=10.0D0 
!   filename(x)='D0_ZH_llbb_1.1fb_5482' 
!   S95_t1(x)%OBid_old=4  
 
!   x=x+1 
!   S95_t1(x)%id=5624
!   S95_t1(x)%expt=' D0'
!   S95_t1(x)%label='D0 Note 5624' 
!   S95_t1(x)%Mhmin=115.0D0
!   S95_t1(x)%Mhmax=200.0D0
!   S95_t1(x)%sep=5.0D0 
!   filename(x)='D0_ppH_WW_ll_2.3fb_5624'
!   S95_t1(x)%OBid_old=7   
!   S95_t1(x)%OBid=7   

  x=x+1 
  S95_t1(x)%id=5472
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='D0 Note 5472' 
  S95_t1(x)%Mhmin=105.0D0
  S95_t1(x)%Mhmax=145.0D0
  S95_t1(x)%sep=10.0D0 
  !filename(x)='D0_WH_lnubb_1.7fb_5472' 
  filename(x)='D0_WH_lnubb_1.7fb_5472_Fig.6a'
  S95_t1(x)%OBid_old=11
  S95_t1(x)%OBid=11
  
  !x=x+1 
  !S95_t1(x)%id=5502
  !S95_t1(x)%expt=' D0'
  !S95_t1(x)%label='D0 Note 5502' 
  !S95_t1(x)%Mhmin=120.0D0
  !S95_t1(x)%Mhmax=200.0D0
  !S95_t1(x)%sep=20.0D0 
  !filename(x)='D0_ppH_WW_ee_0.6fb_5502'  
  !S95_t1(x)%OBid_old=-1

  !x=x+1 
  !S95_t1(x)%id=5332
  !S95_t1(x)%expt=' D0'
  !S95_t1(x)%label='D0 Note 5332' 
  !S95_t1(x)%Mhmin=120.0D0
  !S95_t1(x)%Mhmax=180.0D0
  !S95_t1(x)%sep=20.0D0 
  !filename(x)='D0_ppH_WW_mutau_1fb_5332' 
  !S95_t1(x)%OBid_old=-1
  
  x=x+1 
  S95_t1(x)%id=5485
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='D0 Note 5485' 
  S95_t1(x)%Mhmin=120.0D0
  S95_t1(x)%Mhmax=200.0D0
  S95_t1(x)%sep=20.0D0 
  filename(x)='D0_WH_WWW_llnunu_1fb_5485'
  S95_t1(x)%OBid_old=19 
  S95_t1(x)%OBid=19 

  x=x+1 
  S95_t1(x)%id=9071
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='CDF Note 9071' 
  S95_t1(x)%Mhmin=90.0D0
  S95_t1(x)%Mhmax=250.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='CDF_ppH_tautau_1.8fb_9071_interpol'
  S95_t1(x)%OBid_old=18
  S95_t1(x)%OBid=18

  !x=x+1 
  !S95_t1(x)%id=5331
  !S95_t1(x)%expt=' D0'
  !S95_t1(x)%label='D0 Note 5331' 
  !S95_t1(x)%Mhmin=90.0D0
  !S95_t1(x)%Mhmax=200.0D0
  !S95_t1(x)%sep=10.0D0 
  !filename(x)='D0_ppH_tautau_1fb_5331_interpol'
  !S95_t1(x)%OBid_old=-1

  x=x+1 
  S95_t1(x)%id=8961
  S95_t1(x)%expt='TSM'
  S95_t1(x)%label='hep-ex:0712.2383v1' !CDF Note 8961, D0 Note 5536
  S95_t1(x)%Mhmin=110.0D0
  S95_t1(x)%Mhmax=200.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='CDF_D0_SM_combined_1.0-1.9fb_8961-5536_interpol'
  S95_t1(x)%OBid_old=9
  S95_t1(x)%OBid=9

!   x=x+1 
!   S95_t1(x)%id=5503
!   S95_t1(x)%expt=' D0'
!   S95_t1(x)%label='D0 Note 5503' 
!   S95_t1(x)%Mhmin=100.0D0
!   S95_t1(x)%Mhmax=170.0D0
!   S95_t1(x)%sep=10.0D0 
!   filename(x)='D0_bbH_bb_0.9fb_5503_interpol'
!   S95_t1(x)%OBid_old=14

  !x=x+1 
  !S95_t1(x)%id=8954
  !S95_t1(x)%expt='CDF'
  !S95_t1(x)%label='CDF Note 8954' 
  !S95_t1(x)%Mhmin=90.0D0
  !S95_t1(x)%Mhmax=210.0D0
  !S95_t1(x)%sep=10.0D0 
  !filename(x)='CDF_bbH_bb_1fb_8954'
  !S95_t1(x)%OBid_old=-1

!   x=x+1 
!   S95_t1(x)%id=9236
!   S95_t1(x)%expt='CDF'
!   S95_t1(x)%label='CDF Note 9236' 
!   S95_t1(x)%Mhmin=110.0D0
!   S95_t1(x)%Mhmax=200.0D0
!   S95_t1(x)%sep=10.0D0 
!   filename(x)='CDF_ggH_WW_2.4fb_9236'
!   S95_t1(x)%OBid_old=12
!   S95_t1(x)%OBid=12

!   x=x+1 
!   S95_t1(x)%id=9219
!   S95_t1(x)%expt='CDF'
!   S95_t1(x)%label='CDF Note 9219' 
!   S95_t1(x)%Mhmin=110.0D0
!   S95_t1(x)%Mhmax=150.0D0
!   S95_t1(x)%sep=5.0D0 
!   filename(x)='CDF_WH_lnubb_1.9fb_9219'    
!   S95_t1(x)%OBid_old=13

  x=x+1 
  S95_t1(x)%id=9284
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='CDF Note 9284' 
  S95_t1(x)%Mhmin=90.0D0
  S95_t1(x)%Mhmax=210.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='CDF_bbH_bb_1.9fb_9284'
  S95_t1(x)%OBid_old=10
  S95_t1(x)%OBid=10

  x=x+1 
  S95_t1(x)%id=7307
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='CDF Note 7307' 
  S95_t1(x)%Mhmin=110.0D0
  S95_t1(x)%Mhmax=200.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='CDF_WH_WWW_1.9fb_7307'  
  S95_t1(x)%OBid_old=20
  S95_t1(x)%OBid=20
  
  x=x+1 
  S95_t1(x)%id=2491
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='arXiv:0805.2491' 
  S95_t1(x)%Mhmin=90.0D0
  S95_t1(x)%Mhmax=300.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='D0_ppH_tautau_1fb_2491_interpol'
  S95_t1(x)%OBid_old=17
  S95_t1(x)%OBid=17

!   x=x+1 
!   S95_t1(x)%id=5601
!   S95_t1(x)%expt=' D0'
!   S95_t1(x)%label='D0 Note 5601' 
!   S95_t1(x)%Mhmin=100.0D0
!   S95_t1(x)%Mhmax=150.0D0
!   S95_t1(x)%sep=10.0D0 
!   filename(x)='D0_Hgaga_2.27fb_5601'
!   S95_t1(x)%OBid_old=22
!   S95_t1(x)%OBid=22

  x=x+1 
  S95_t1(x)%id=1514
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='hep-ex/0803.1514v1 (D0)' 
  S95_t1(x)%Mhmin=70.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='D0_gaga_1.1fb_1514'
  S95_t1(x)%OBid_old=23
  S95_t1(x)%OBid=23
  
!   x=x+1 
!   S95_t1(x)%id=9166
!   S95_t1(x)%expt='CDF'
!   S95_t1(x)%label='CDF Note 9166' 
!   S95_t1(x)%Mhmin=110.0D0
!   S95_t1(x)%Mhmax=150.0D0
!   S95_t1(x)%sep=5.0D0 
!   filename(x)='CDF_VH_Metbb_1.97fb_9166_interpol'  
!   S95_t1(x)%OBid_old=21
!   S95_t1(x)%OBid=21
  
  x=x+1 
  S95_t1(x)%id=9290
  S95_t1(x)%expt='TSM'
  S95_t1(x)%label='arXiv:0804.3423 [hep-ex]' !CDF Note 9290, D0 Note 5645
  S95_t1(x)%Mhmin=110.0D0
  S95_t1(x)%Mhmax=200.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='CDF_D0_SM_combined_1.0-2.4fb_9290-5645_interpol'
  S95_t1(x)%OBid_old=25
  S95_t1(x)%OBid=25

  x=x+1 
  S95_t1(x)%id=9248
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='CDF Note 9248' 
  S95_t1(x)%Mhmin=110.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='CDF_SMcomb_tautau_2.0fb_9248_interpol'
  S95_t1(x)%OBid_old=24
  S95_t1(x)%OBid=24

  x=x+1 
  S95_t1(x)%id=3556
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='hep-ex/0805.3556 (D0)' 
  S95_t1(x)%Mhmin=90.0D0
  S95_t1(x)%Mhmax=220.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='D0_bbH_bb_1.0fb_3556_interpol'
  S95_t1(x)%OBid_old=15
  S95_t1(x)%OBid=15

  x=x+1 
  S95_t1(x)%id=3930
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='hep-ex/0809.3930 (CDF)' 
  S95_t1(x)%Mhmin=110.0D0
  S95_t1(x)%Mhmax=200.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='CDF_ggH_WW_3.0fb_3930'
  S95_t1(x)%OBid_old=-1
  S95_t1(x)%OBid=27

  x=x+1 
  S95_t1(x)%id=5757
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='D0 Note 5757' 
  S95_t1(x)%Mhmin=115.0D0
  S95_t1(x)%Mhmax=200.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='D0_ppH_WW_ll_3.0fb_5757'
  S95_t1(x)%OBid_old=26
  S95_t1(x)%OBid=26

  x=x+1 
  S95_t1(x)%id=9463
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='CDF Note 9463' 
  S95_t1(x)%Mhmin=100.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='CDF_WH_lnubb_2.7fb_9463'
  S95_t1(x)%OBid_old=-1
  S95_t1(x)%OBid=13

  x=x+1 
  S95_t1(x)%id=5570
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='D0 Note 5570' 
  S95_t1(x)%Mhmin=100.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='D0_ZH_llbb_2.3fb_5570'
  S95_t1(x)%OBid_old=-1
  S95_t1(x)%OBid=4

  x=x+1 
  S95_t1(x)%id=5726
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='D0 Note 5726' 
  S95_t1(x)%Mhmin=90.0D0
  S95_t1(x)%Mhmax=220.0D0
  S95_t1(x)%sep=10.0D0 
  filename(x)='D0_bbH_bb_2.6fb_5726_sq_interpol'
  S95_t1(x)%OBid_old=-1
  S95_t1(x)%OBid=14

  x=x+1 
  S95_t1(x)%id=4493
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='hep-ex/0807.4493 (CDF)' 
  S95_t1(x)%Mhmin=110.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='CDF_ZH_llbb_1fb_4493_interpol'
  S95_t1(x)%OBid_old=-1
  S95_t1(x)%OBid=1

  x=x+1 
  S95_t1(x)%id=9475
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='CDF Note 9475' 
  S95_t1(x)%Mhmin=100.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='CDF_ZH_llbb_2.4fb_9475'
  S95_t1(x)%OBid_old=-1
  S95_t1(x)%OBid=2

  x=x+1 
  S95_t1(x)%id=9465
  S95_t1(x)%expt='TSM'
  S95_t1(x)%label='arXiv:0808.0534 [hep-ex]' !CDF Note 9465, D0 Note 5754
  S95_t1(x)%Mhmin=155.0D0
  S95_t1(x)%Mhmax=200.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='CDF_D0_SM_combined_3.0fb_9465-5754_CLs'
  !filename(x)='CDF_D0_SM_combined_3.0fb_9465-5754_bayesian'
  S95_t1(x)%OBid_old=28
  S95_t1(x)%OBid=28

  x=x+1 
  S95_t1(x)%id=5737
  S95_t1(x)%expt=' D0'
  S95_t1(x)%label='D0 Note 5737'
  S95_t1(x)%Mhmin=100.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=5.0D0 
  filename(x)='D0_gaga_2.68fb_5737'
  S95_t1(x)%OBid_old=-1
  S95_t1(x)%OBid=22

  x=x+1
  S95_t1(x)%id=9483
  S95_t1(x)%expt='CDF'
  S95_t1(x)%label='CDF note 9483'
  S95_t1(x)%Mhmin=105.0D0
  S95_t1(x)%Mhmax=150.0D0
  S95_t1(x)%sep=5.0D0
  filename(x)='CDF_VH_Metbb_2.1fb_9483'
  S95_t1(x)%OBid_old=3
  S95_t1(x)%OBid=3

  !x=x+1 
  !S95_t1(x)%id=9500
  !S95_t1(x)%expt='CDF'
  !S95_t1(x)%label='CDF Note 9500'
  !S95_t1(x)%Mhmin=110.0D0
  !S95_t1(x)%Mhmax=200.0D0
  !S95_t1(x)%sep=5.0D0 
  !filename(x)='CDF_ggH_WW_3.0fb_9500_interpol'
  !S95_t1(x)%OBid_old=27


  ! checks we've filled the whole array
  if(x.ne.xend)then
   stop'error in initializetables1 (a)'
  endif 
 
  ! do loop to read in S95 tables 
  do x=xbeg,xend
  
   fullfilename=trim(adjustl(pathname))//'Expt_tables/' &
              &   //trim(adjustl(S95_t1(x)%expt))//'tables/' &
	      &   //trim(filename(x))//'.txt'
	
   call read_tabletype1(S95_t1(x),5,3,fullfilename)	      
     
  enddo	
 	
  deallocate(filename)
	 	
 end subroutine initializetables1
 
 !************************************************************		
 subroutine read_tabletype1(t1,skip,col,fullfilename)
 !************************************************************	 
 !uses t1%Mhmin,t1%Mhmax,t1%sep and fullfilename to fill t1%nx
 !and allocate&fill t1%dat
  !--------------------------------------input
  type(table1) :: t1  
  integer :: skip,col
  character(LEN=200) :: fullfilename
  !-----------------------------------internal
  integer :: i,n	
  double precision :: Mh1dummy,Mh1dummy_store
  !-------------------------------------------
  
  t1%nx=nint((t1%Mhmax-t1%Mhmin)/t1%sep)+1
   
  allocate(t1%dat(t1%nx,col-1))
 
  open(10, file=(trim(fullfilename)))
   
  do i=1,skip
   read(10,*) !skip lines
  enddo 
   
  Mh1dummy_store = t1%Mhmin-t1%sep
  do i=1,t1%nx
   read(10,*)Mh1dummy,(t1%dat(i,n),n=1,col-1) 

   ! checks that Mh1 are evenly spaced as expected
   if((abs(Mh1dummy-Mh1dummy_store-t1%sep).gt.1.0D-7) &
     &  .or.(abs(Mh1dummy-(t1%Mhmin+dble(i-1)*t1%sep)).gt.1.0D-7))then
    stop 'error in read_tabletype1 (a)'
   endif     	
	 
   Mh1dummy_store=Mh1dummy	 
	 
  enddo  
   
  close(10) 
  
 end subroutine read_tabletype1
 !************************************************************
end module S95tables_type1
!************************************************************
