! This file is part of HiggsBounds
!  -KW

! interfaces with SLHAlib2-2
! At the moment, this is not a supported part of HiggsBounds
!(if you would find this useful, drop us an email and we'll
! put this feature higher on out priority list)

#include "PDG.h"

	subroutine readSLHAdata(additional,n_additional,
     &               Mh,Gammatot,BrhjWW,BrhjZZ,
     &	             Brhjbb,Brhjtautau,Brhjhihi,Brhjgaga,Brhjgg,argv,notvalid)
	implicit none

#include "SLHA.h"

	integer error
	integer n_additional	
	double precision additional(n_additional)	
	double precision Mh(3),Gammatot(3)
	double precision BrhjWW(3),Brhjbb(3),Brhjtautau(3),Brhjgaga(3)
	double precision Brhjgg(3)	
	double precision BrhjZZ(3),Brhjhihi(3,3)	
	double complex slhadata(nslhadata)
	double precision notvalid
	double precision severity	
        integer i,j

	character*80 argv
	
	call SLHARead(error, slhadata, argv, 1)
	if( error .ne. 0 ) stop "Read error"

	severity=SPInfo_Severity
	if(nint(severity).eq.4)stop 'Severity=4: this SLHA data should not be used'

        notvalid=invalid

        if(n_additional.ne.2)stop 'change n_additional or subroutine readSLHAdata'
        additional(1)=Mass_MHp
	additional(2)=MinPar_TB

        Mh(1)=Mass_Mh0
        Mh(2)=Mass_MHH
        Mh(3)=Mass_MA0

        Gammatot(1)=SLHAGetDecay(slhadata,PDG_h0,0,0,0)
        Gammatot(2)=SLHAGetDecay(slhadata,PDG_HH,0,0,0)
        Gammatot(3)=SLHAGetDecay(slhadata,PDG_A0,0,0,0)

        BrhjWW(1)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_W,-PDG_W)
        BrhjWW(2)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_W,-PDG_W)
        BrhjWW(3)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_W,-PDG_W)

        BrhjZZ(1)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_Z,PDG_Z)
        BrhjZZ(2)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_Z,PDG_Z)
        BrhjZZ(3)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_Z,PDG_Z)
        
	Brhjbb(1)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_bottom,-PDG_bottom)
	Brhjbb(2)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_bottom,-PDG_bottom)
	Brhjbb(3)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_bottom,-PDG_bottom)
        
	Brhjtautau(1)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_tau,-PDG_tau)
	Brhjtautau(2)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_tau,-PDG_tau)
	Brhjtautau(3)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_tau,-PDG_tau)
        
	Brhjgaga(1)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_photon,PDG_photon)
	Brhjgaga(2)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_photon,PDG_photon)
	Brhjgaga(3)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_photon,PDG_photon)	
	        
	Brhjgg(1)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_gluon,PDG_gluon)
	Brhjgg(2)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_gluon,PDG_gluon)
	Brhjgg(3)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_gluon,PDG_gluon)	
	
	do j=1,3
	 do i=1,3 
	  Brhjhihi(j,i)=0.0D0
	 enddo
	enddo
	
	Brhjhihi(1,2)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_HH,PDG_HH)
	Brhjhihi(1,3)=SLHAGetDecay(slhadata,PDG_h0,2,PDG_A0,PDG_A0)
		
	Brhjhihi(2,1)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_h0,PDG_h0)	
	Brhjhihi(2,3)=SLHAGetDecay(slhadata,PDG_HH,2,PDG_A0,PDG_A0)	
	
	Brhjhihi(3,1)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_h0,PDG_h0)
	Brhjhihi(3,2)=SLHAGetDecay(slhadata,PDG_A0,2,PDG_HH,PDG_HH)	
	
	end

